'use strict';

var MedicaoFisicaController = angular.module('MedicaoFisicaController', []);

MedicaoFisicaController.controller('MedicaoFisicaCtrl', ['$scope', '$routeParams', '$filter', '$rootScope', '$location', 'Construcao', 'Material', 'Compra', 'DiarioObra', 'CacheApp',
  ($scope, $routeParams, $filter, $rootScope, $location, Construcao, Material, Compra, DiarioObra, CacheApp) => {

    $scope.getEtapasConstrucao = () => {
        Construcao.getEtapasConstrucao($scope.construcao.Id,
            (data) => {

                if (!$scope.orcamento) {
                    $scope.orcamento = [];
                    data.Instance.forEach(etapa => {
                        $scope.orcamento.push({
                            IdCount: i,
                            IdConstrucao: $scope.construcao.Id,
                            Id: etapa.Id,
                            IdEtapa: etapa.Id,
                            Ordem: etapa.Ordem,
                            Descricao: etapa.Descricao,
                            Valor: etapa.ValorOrcado,
                            ValorBDIEncargos: etapa.ValorBDIEncargos,
                            ValorBDI: etapa.ValorBDI,
                            ValorEncargos: etapa.ValorEncargos,
                            SomaItem: etapa.SomaItem,
                            Nivel: etapa.Nivel,
                            Novo: false,
                            show: (etapa.Nivel == 1),
                            showSubItem: false,
                            open: false,
                            Itens: [],
                            isEtapa: true,
                            Medicao: $scope.getMedicao(etapa)
                        });
                    });
                }
                else {
                    data.Instance.forEach(etapa => {
                        var etapaAtual = $scope.orcamento.filter(o => o.Id == etapa.Id)[0];
                        etapaAtual.Medicao = $scope.getMedicao(etapa);
                        etapaAtual.Itens.forEach((item,i) => {
                            item.Medicao = $scope.getMedicaoItem(etapaAtual, item)
                        })
                    });
                }

                for (var i in $scope.orcamento) {
                    if (!$scope.orcamento[i].SomaItem) {
                        var soma = 0;
                        $scope.orcamento.forEach(l => {
                            if (l.Ordem.indexOf($scope.orcamento[i].Ordem + '.') == 0)
                                soma += l.Valor*(l.Medicao.Medido/100);
                        });
                        if (soma > 0) {
                            $scope.orcamento[i].Medicao.Medido = (soma/$scope.orcamento[i].Valor)*100;
                            $scope.orcamento[i].Medicao.Faltam = 100-$scope.orcamento[i].Medicao.Medido;
                        }
                    }
                }
            }
        );
    }

    $scope.abrirEtapa = (Ordem) => {
        for (var i in $scope.orcamento) {
            var item = $scope.orcamento[i];
            if (Ordem.indexOf(item.Ordem + '.') == 0) {
                if (item.SomaItem)
                    $scope.detalheEtapa(item);
                else
                    $scope.expandeEtapa(item);
            }
        }
    }

    $scope.detalheEtapa = (etapa) => {
        etapa.open = !etapa.open;
        if (!etapa.consultado && (etapa.Itens || etapa.Itens.length == 0) )
            $scope.getCustoDetalhadoEtapaConstrucao(etapa, () => {
                etapa.consultado = true;
            });

        etapa.showSubItem = !etapa.showSubItem;
    }
  
    $scope.detalheComposicao = (composicao) => {
        composicao.open = !composicao.open;
        if (composicao.Medicao.Medicoes)
            composicao.Medicao.Medicoes.forEach(m => {
                switch (m.TipoVinculo) {
                    case 1:
                        var forn = $scope.fornecedores.filter(f => f.IdFornecedor == m.IdFornecedorCliente);
                        if (forn.length > 0) {
                            m.RazaoSocial = forn[0].RazaoSocial;
                        }
                        break;
                    case 2:
                        var func = $scope.funcionarios.filter(f => f.Id == m.IdFuncionario);
                        if (func.length > 0) {
                            m.NomeFuncionario = func[0].Nome;
                        }
                        break;
                }
            })
        composicao.HtmlSubItem = $scope.getHtmlListaMedicao;
    }

    $scope.expandeEtapa = (item) => {
        item.open = !item.open;
        
        if (item.open)
            for (var i in $scope.orcamento) {
                if ($scope.orcamento[i].Ordem.indexOf(item.Ordem + '.') == 0
                    && item.IdEtapa != $scope.orcamento[i].IdEtapa
                    &&  $scope.orcamento[i].Nivel == item.Nivel+1 ) {
                    $scope.orcamento[i].show = true;
                    
                    if (!item.Itens) continue;

                    if (!item.consultado && item.Itens && item.Itens.length == 0)
                        $scope.getCustoDetalhadoEtapaConstrucao(item, () => {
                            item.consultado = true;
                            item.showSubItem = item.Itens && item.Itens.length > 0;
                        });
                    else if (item.Itens.length > 0)
                        item.showSubItem = true;
                }
            }
        else {
            for (var i in $scope.orcamento) {
                if ($scope.orcamento[i].Ordem.indexOf(item.Ordem + '.') == 0
                    && item.IdEtapa != $scope.orcamento[i].IdEtapa) {
                    $scope.orcamento[i].show = false;
                    $scope.orcamento[i].open = false;
                    $scope.orcamento[i].showSubItem = false;
                }
            }

            item.showSubItem = false;
        }
    }

    $scope.getCustoDetalhadoEtapaConstrucao = (etapa, callBackFunction) => {
        etapa.Itens = undefined;
        Construcao.getCustoDetalhadoEtapaConstrucao($scope.construcao.Id, etapa.IdEtapa,
            (data) => {
                etapa.Itens = [];
                var count = 0;

                for (var i in data.Instance) {
                    var item = data.Instance[i];
                    var novoItem = {
                        IdCount: count,
                        IdCompra: item.IdCompra,
                        IdConstrucao: $scope.construcao.Id,
                        IdEtapa: etapa.Id,
                        IdMaterial: item.IdMaterial,
                        Ordem: item.Ordem,
                        Codigo: item.Codigo,
                        Descricao: item.Material,
                        IdUnidade: item.IdUnidade,
                        UnidadeSigla: item.UnidadeSigla,
                        Quantidade: item.Planejado.Quantidade,
                        Valor: item.Planejado.Custo,
                        ValorBDIEncargos: item.Planejado.CustoBDIEncargos,
                        ValorBDI: item.Planejado.CustoBDI,
                        ValorEncargos: item.Planejado.CustoEncargos,
                        Novo: false,
                        show: true,
                        open: false,
                        Itens: [],
                        isEtapa: false,
                        Medicao: $scope.getMedicaoItem(etapa, item),
                        ListaMedicao: $scope.getHtmlListaMedicao()
                    };

                    etapa.Itens.push(novoItem);
                    count++;
                }

                if (callBackFunction)
                    callBackFunction();
                
            });
    }

    $scope.cancelarAvancoEtapa = (item) => {
        item.Medindo = false;
    }
    $scope.adicionarAvancoEtapa = (item) => {
        item.Medindo = true;
        item.AvancoData = CacheApp.getData($filter("date")(Date.now(), 'yyyy-MM-ddT06:10:00Z'));
        item.EditarMedicao = $scope.getHtmlEditarMedicaoEtapa();
    }

    $scope.registraAvancoEtapa = (etapa) => {
        var medicao = {
            IdConstrucao: $scope.construcao.Id, 
            IdEtapa: etapa.Id,
            Quantidade: etapa.AvancoPercento,
            Data: $filter("date")(etapa.AvancoData, 'yyyy-MM-dd')
        };

        Compra.setAvancoFisicoEtapa(medicao,
            (data) => {
                $scope.getMedicoesFisicas();
            });
    }

    $scope.getHtmlListaMedicao = () => {
        return `
            <div class="panel panel-medicao">
                <div class="panel-heading">
                    <div class="row">
                        <div class="notShowMobile">
                            <div class="col-md-2 col-sm-2 text-center" ng-click="fieldOrder = 'Data'; reverse = !reverse" style="cursor: pointer;">Data</div>
                            <div class="col-md-1 col-sm-1 text-center" ng-click="fieldOrder = 'Medido'; reverse = !reverse" style="cursor: pointer;">Medido</div>
                            <div class="col-md-2 col-sm-2 text-center" ng-click="fieldOrder = 'Quantidade'; reverse = !reverse" style="cursor: pointer;">Quant.</div>
                            <div class="col-md-5 col-sm-5">Fornecedor / Funcionário</div>
                            <!-- div class="col-md-1 col-sm-1 text-center" ng-click="fieldOrder = 'Hora'; reverse = !reverse" style="cursor: pointer;">Tempo</div>
                            <div class="col-md-1 col-sm-1 text-center" ng-click="fieldOrder = 'Avaliacao'; reverse = !reverse" style="cursor: pointer;">Avaliação</div -->
                        </div>
                        <div class="showMobile">
                            <div class="col-xs-8">Medição Registrada</div>
                            <div class="col-xs-4 text-right">
                                <span class="total"><formata-numero format-valor="totalAvanco" format-tipo="'real'"></formata-numero> <small>%</small></span>
                            </div>
                        </div>
                    </div>
                </div>
                <ul class="list-group">
                    <mensagemvazio 
                        msg-grid="true"
                        msg-click="adicionarAvanco(item, subItem)" 
                        msg-lista="subItem.Medicao.Medicoes" 
                        msg-texto="'Nenhuma medição física registrada'" 
                        msg-subtexto="'e registre a medição física diária da sua ' + construcao.TipoDescricao" 
                        msg-permissao="'SET_AVANCO'" 
                        msg-acessos="construcao.Acessos"></mensagemvazio>
                    <li class="list-group-item LinhaLista" ng-mouseover="mouseovermed=true" ng-mouseleave="mouseovermed=false" ng-repeat="avanco in subItem.Medicao.Medicoes | orderBy: fieldOrder : reverse | filter: pesquisa" ng-click=" $event.stopPropagation();">
                        <div class="row" ng-show="!avanco.Novo">
                            <div class="notShowMobile">
                                <div class="col-md-2 col-sm-2 text-center">{{avanco.Data | date:'dd/MM/yyyy'}}</div>
                                <div class="col-md-1 col-sm-1 text-center"><formata-numero format-valor="avanco.PercentualItem" format-tipo="'real'"></formata-numero> <small>%</small></div>
                                <div class="col-md-2 col-sm-2 text-center"><formata-numero format-valor="avanco.Quantidade" format-tipo="'real'"></formata-numero> <small>({{subItem.UnidadeSigla}})</small></div>
                                <div class="col-md-5 col-sm-5">{{avanco.TipoVinculo == 1 ? avanco.RazaoSocial : avanco.NomeFuncionario}}</div>
                                <!-- div class="col-md-1 col-sm-1 text-center">{{avanco.Hora}} <small>{{avanco.Hora ? '(H)' : ''}}</small></div>
                                <div class="col-md-1 col-sm-1 text-center">{{avanco.Avaliacao}}</div -->
                                <div class="col-md-2 col-sm-2 text-right">
                                    <div ng-show="mouseovermed">
                                        <itemeditar btn-click="alteraAvanco(avanco); $event.stopPropagation();" btn-permissao="'SET_AVANCO'" btn-acessos="construcao.Acessos"></itemeditar>
                                        <itemexcluir btn-click="excluiAvanco(item, subItem, avanco); $event.stopPropagation();" btn-permissao="'DEL_AVANCO'" btn-acessos="construcao.Acessos"></itemexcluir>
                                    </div>
                                </div>
                            </div>
                            <div class="showMobile">
                                <div class="LinhaListaHand" ng-click="item.SomaItem ? detalheEtapa(item) : expandeEtapa(item)">
                                    <div class="col-xs-12">
                                        {{avanco.Etapa}} - {{avanco.Material}} <br />
                                        Data: {{avanco.Data | date:'dd/MM/yyyy'}} <br />
                                        Medido: <formata-numero format-valor="avanco.Quantidade" format-tipo="'real'"> <small>({{avanco.UnidadeSigla}})</small>
                                        = <formata-numero format-valor="avanco.PercentualItem" format-tipo="'real'"></formata-numero><small>%</small> <br />
                                        Obra: <formata-numero format-valor="avanco.PercentualObra" format-tipo="'real'"></formata-numero><small>%</small> <br /> <br />
                                    </div>
                                    <div class="col-xs-7">
                                        <div class="progress">
                                            <div class="progress-bar progress-bar-orange" role="progressbar" aria-valuenow="{{avanco.PercItemAcum}}" aria-valuemin="0" aria-valuemax="100" style="width: {{avanco.PercItemAcum}}%">
                                                <span  class="numero"> <formata-numero format-valor="avanco.PercItemAcum" format-tipo="'real'"></formata-numero><small>%</small> </span>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="col-xs-5 text-right" ng-click="$event.stopPropagation()">
                                        <div ng-show="mouseover">
                                            <itemeditar btn-click="alteraAvanco(avanco); $event.stopPropagation();" btn-permissao="'SET_AVANCO'" btn-acessos="construcao.Acessos"></itemeditar>
                                            <itemexcluir btn-click="excluiAvanco(item, subItem, avanco); $event.stopPropagation();" btn-permissao="'DEL_AVANCO'" btn-acessos="construcao.Acessos"></itemexcluir>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="row" ng-show="avanco.Novo">
                            <div dynamic="avanco.Editar"></div>
                        </div>
                    </li>
                </ul>
            </div>
        `;
    }

    $scope.getHtmlEditarMedicao = () => {
        return `
        <form class="form col-lg-12 col-md-12 col-sm-12 col-xs-12 center-block" name="formAvanco">
            <div class="form-group">
                <div class="row" ng-show="deuErro">
                    <div class="col-md-4 col-md-offset-4 col-sm-4 col-sm-offset-4">
                        <mensagemform />
                    </div>
                </div>
            </div>
            <div class="form-group">
                <div class="row">
                    <div class="col-lg-7 col-md-7 col-sm-7 col-xs-12">
                        <div class="row" style="padding-bottom: 10px;">
                            <div class="col-lg-6 col-md-6 col-sm-6 col-lx-12">
                                <label>Data Medição: </label>
                                <input type="date" class="form-control" ng-model="avanco.Data" required datasafari />
                            </div>
                            <div class="col-lg-6 col-md-6 col-sm-6 col-lx-12">
                                <label>Quantidade: </label>
                                <div class="input-group">
                                    <input type="text" class="form-control" placeholder="Quantidade" ng-model="avanco.Quantidade" ng-keyup="atualiza(0,subItem,avanco)" ui-number-mask="decimals" required>
                                    <span class="input-group-addon">
                                        {{subItem.UnidadeSigla}}
                                    </span>
                                </div>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-lg-6 col-md-6 col-sm-6 col-lx-12">
                                <label>Valor: </label>
                                <div class="input-group">
                                    <input type="text" class="form-control" placeholder="Valor" ng-model="avanco.ValorMedido" ng-keyup="atualiza(2,subItem,avanco)" ui-number-mask="decimals" required>
                                    <span class="input-group-addon">
                                        R$
                                    </span>
                                </div>
                            </div>
                            <div class="col-lg-6 col-md-6 col-sm-6 col-lx-12">
                                <label>Percentual: </label>
                                <div class="input-group">
                                    <input type="text" class="form-control" placeholder="Porcentagem" ng-model="avanco.Percento" ng-init="avanco.Percento = avanco.PercentualItem" ng-keyup="atualiza(1,subItem,avanco)" ui-number-mask="decimals" required>
                                    <span class="input-group-addon">
                                        %
                                    </span>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="col-lg-3 col-md-3 col-sm-3 col-xs-12">
                        <div class="row" style="padding-bottom: 15px;">
                            <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
                                Medido: 
                                <div class="progress" style="height: 30px;">
                                    <div class="progress-bar progress-bar-purple" role="progressbar" aria-valuenow="{{subItem.Medicao.Medido}}" aria-valuemin="0" aria-valuemax="100" style="width: {{subItem.Medicao.Medido}}%">
                                        <formata-numero format-valor="subItem.Medicao.Medido" format-tipo="\'real\'"></formata-numero><small>%</small>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-lg-6 col-md-6 col-sm-6 col-xs-6">
                                Medido: 
                                <div class="fontePreco">
                                    <formata-numero format-valor="subItem.Medicao.Quantidade" format-tipo="\'real\'"></formata-numero><small>{{subItem.UnidadeSigla}}</small> 
                                </div>
                            </div>
                            <div class="col-lg-6 col-md-6 col-sm-6 col-xs-6">
                                Falta Medir: 
                                <div class="fontePreco">
                                    <formata-numero format-valor="subItem.Medicao.AMedir" format-tipo="\'real\'"></formata-numero><small>{{subItem.UnidadeSigla}}</small> 
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="col-md-2 col-sm-2 col-lg-2 col-xs-12 text-center">
                        <itemsalvar ng-click="(!formAvanco.$invalid && registraAvanco(item, subItem, avanco)); $event.stopPropagation();" />
                        <itemcancelar ng-click="cancelaAvanco(subItem, avanco); $event.stopPropagation();" />
                    </div>
                </div>
            </div>
            <hr style="border-top: 1px solid #FAA200">
            <div class="form-group">
                <div class="row">
                    <div class="col-md-12 col-sm-12 col-lg-12 col-xs-12"> 
                        <div class="btn-group" data-toggle="buttons">
                            <label class="btn btn-default" ng-class="{'active': avanco.TipoVinculo == 0}" ng-click="setCheckVincular(avanco,0)">
                                <input type="radio" name="tipoNF" id="optNF" value="0" autocomplete="off" ng-class="{'checked': avanco.TipoVinculo == 0}"> Sem Executor
                            </label>
                            <label class="btn btn-default" ng-class="{'active': avanco.TipoVinculo == 1}" ng-click="setCheckVincular(avanco,1)">
                                <input type="radio" name="tipoNF" id="optRecibo" value="1" autocomplete="off" ng-class="{'checkd': avanco.TipoVinculo == 1}"> Fornecedor
                            </label>
                            <label class="btn btn-default" ng-class="{'active': avanco.TipoVinculo == 2}" ng-click="setCheckVincular(avanco,2)">
                                <input type="radio" name="tipoNF" id="optCupom" value="2" autocomplete="off" ng-class="{'checkd': avanco.TipoVinculo == 2}"> Colaborador
                            </label>
                        </div>
                    </div>
                </div>
            </div>
            <div ng-if="avanco.TipoVinculo != 0" dynamic="avanco.fornecedorColab"></div>
        </form>`;
    }

    $scope.setCheckVincular = (medicao, tipo) => {
        medicao.TipoVinculo = tipo
        switch (medicao.TipoVinculo) {
            case 1:
                medicao.fornecedorColab = $scope.getHtmlVincularFornecedor()
                break;
            case 2:
                medicao.fornecedorColab = $scope.getHtmlVincularFuncionario()
                break;
            default:
                medicao.fornecedorColab = ''
                break;
        }
    }

    $scope.getHtmlEditarMedicaoEtapa = () => {
        return '' +
        '   <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">' +
        '        <div class="panel panel-medicao"> ' +
        '            <div class="panel-heading"> ' +
        '                   Medição dos Serviços da Etapa' +
        '            </div> ' +
        '            <ul class="list-group"> ' +
        '                <li class="list-group-item LinhaLista"> ' +
        '                    <div class="row"> ' +

        '<form class="form center-block" name="formAvanco">' +
        '   <div class="col-lg-7 col-md-7 col-sm-7 col-xs-12">' +
        '       <div class="form-group">' +
        '           <div class="row">' +
        '               <div class="col-lg-4 col-md-4 col-sm-4 col-lx-12">' +
        '                   <label>Data Medição: </label>'+
        '			        <input type="date" class="form-control" ng-model="item.AvancoData" required datasafari />' +
        '		        </div>' +
        '               <div class="col-lg-4 col-md-4 col-sm-4 col-lx-12">' +
        '                     <label>Percentual: </label>'+
        '                   <div class="input-group">' +
        '                       <input type="text" class="form-control" placeholder="Porcentagem" ng-model="item.AvancoPercento" ui-number-mask="decimals" required>' +
        '                       <span class="input-group-addon">' +
        '                           %' +
        '                       </span>' +
        '                   </div>' +
        '               </div>' +
        '           </div>' +
        '       </div>' +
        '   </div>' +
        '   <div class="col-md-2 col-sm-2 col-lg-2 col-xs-12 text-center">' +
        '	     <itemsalvar ng-click="(!formAvanco.$invalid && registraAvancoEtapa(item)); $event.stopPropagation();" />' +
        '	     <itemcancelar ng-click="cancelarAvancoEtapa(item); $event.stopPropagation();" />' +
        '   </div>' +
        '</form>' + 

        '                    </div> ' +
        '                </li> ' +
        '            </ul> ' +
        '        </div> ' +
        '        </div> ';

    }

    $scope.getHtmlVincularFuncionario = () => {
        return `
            <div class="form-group">
                <div class="row">
                    <div class="col-lg-7 col-md-7 col-sm-7 col-xs-12">
                        <label>Colaborador: </label>
                        <select class="form-control"
                            ng-model="avanco.FuncionarioSelecionado"
                            ng-options="(funcionario.Nome + ' (' + funcionario.Funcao + ') ') for funcionario in funcionarios track by funcionario.Id" required>
                            <option style="display:none" value=""> Selecione o Colaborador </option>
                        </select>
                        <div class="showMobile"> <br /> </div> 
                    </div>
                    <!-- div class="col-lg-3 col-md-3 col-sm-3 col-xs-12">
                        <div class="row">
                            <div class="col-lg-6 col-md-6 col-sm-6 col-xs-12">
                                <label>Tempo: </label>
                                <div class="input-group">
                                    <input type="text" class="form-control" placeholder="" ng-model="avanco.Hora" ui-number-mask="0" required>
                                    <span class="input-group-addon">H</span>
                                </div>
                            </div>
                            <div class="col-lg-6 col-md-6 col-sm-6 col-xs-12">
                                <label>Avaliação: </label>
                                <select class="form-control"
                                    ng-model="avanco.AvaliacaoSelecionado"
                                    ng-options="avaliacao.Descricao for avaliacao in listaAvaliacao track by avaliacao.Id" required>
                                    <option style="display:none" value=""> Avaliação </option>
                                </select>
                            </div>
                        </div>
                    </div -->
                </div>
            </div>
        `;
    }

    $scope.getListaFuncionario = () => {
        DiarioObra.getListaFuncionario($scope.construcao.Id,
            (data) => {
                $scope.funcionarios = data.Instance;
            });
    }

    $scope.getHtmlVincularFornecedor = () => {
        return `
            <div class="form-group">
                <div class="row">
                    <div class="col-lg-7 col-md-7 col-sm-7 col-xs-12">
                        <label>Fornecedor:</label>
                        <dropdowncomplete
                            ddc-placeholder="'Digite o Fornecedor'"
                            ddc-mensagemvazio="'NENHUM FORNECEDOR ENCONTRADO'"
                            ddc-showcodigo="false"
                            ddc-showvalor="false"
                            ddc-hideadd="true"
                            ddc-construcao="construcao"
                            ddc-item="avanco"
                            ddc-lista="listaFornecedor"
                            set-selecionado="setSelecionadoFornecedor(avanco,selecionado)"
                            get-lista="getListaFornecedor(texto)"
                            click-add="novoFornecedor()">
                        </dropdowncomplete>
                        <div class="showMobile"> <br /> </div> 
                    </div>
                    <!-- div class="col-lg-3 col-md-3 col-sm-3 col-xs-12">
                        <div class="row">
                            <div class="col-lg-6 col-md-6 col-sm-6 col-xs-12">
                                <label>Tempo: </label>
                                <div class="input-group">
                                    <input type="text" class="form-control" placeholder="" ng-model="avanco.Hora" ui-number-mask="0" required>
                                    <span class="input-group-addon">H</span>
                                </div>
                            </div>
                            <div class="col-lg-6 col-md-6 col-sm-6 col-xs-12">
                                <label>Avaliação: </label>
                                <select class="form-control"
                                    ng-model="avanco.AvaliacaoSelecionado"
                                    ng-options="avaliacao.Descricao for avaliacao in listaAvaliacao track by avaliacao.Id" required>
                                    <option style="display:none" value=""> Avaliação </option>
                                </select>
                            </div>
                        </div>
                    </div -->
                </div>
            </div>
        `;
    }

    /* override getLista(texto)  */
    $scope.getListaFornecedor = (texto) => {
        $scope.listaFornecedor = $filter('filter')($scope.fornecedores, {RazaoSocial: texto});
    }

    /* override clickAdd()  */
    $scope.novoFornecedor = () => {
    }

    /* override setSelecionado(selecionado)  */
    $scope.setSelecionadoFornecedor = (medicao,selecionado) => {
        medicao.RazaoSocial = selecionado.RazaoSocial;
        medicao.Cnpj = selecionado.Cnpj;
        medicao.IdFornecedorCliente = selecionado.IdFornecedor;
    }

    $scope.getFornecedores = () => {
        var params = {
            IdClienteDono: $scope.construcao.IdClienteDono
        };
        Compra.getFornecedores(params,
            (data) => {
                $scope.fornecedores = data.Instance;
            });
    }

    /* FIM EDITAR ETAPA */

    /* EDITAR COMPOSIÇÃO */
    $scope.getMedicoesFisicas = () => {
        Material.getMedicoesFisicas($scope.construcao.Id, $scope.paginacao, (data) => {
            $scope.totalAvanco = 0;
            if (!$scope.listaAvanco) {
                $scope.listaAvanco = [];
                var count = 0;
                data.Instance.forEach(med => {
                    $scope.totalAvanco += med.PercentualObra;
                    med.Data = new Date(med.Data);
                    med.OldCount = med.Quantidade;
                    med.IdCount = count++;
                    med.ValorMedido = med.ValorItem;
                    med.TipoVinculoOld = med.TipoVinculo;
                    $scope.listaAvanco.push(med);
                });

                if (data.Instance.length > 0)
                    $scope.getSomeData = true;
                else
                    $scope.getSomeData = false;
            }
            else {
                data.Instance.forEach(med => {
                    $scope.totalAvanco += med.PercentualObra;
                    var oldMed = $scope.listaAvanco.filter(la => la.IdCompra == med.IdCompra)[0]
                    if (oldMed) {
                        oldMed.Data = new Date(med.Data);
                        oldMed.Quantidade = med.Quantidade;
                        oldMed.OldCount = med.Quantidade;
                        oldMed.ValorItem = med.ValorItem;
                        oldMed.ValorMedido = med.ValorItem;
                        oldMed.PercentualEtapa = med.PercentualEtapa;
                        oldMed.PercentualItem = med.PercentualItem;
                        oldMed.PercItemAcum = med.PercItemAcum;
                        oldMed.IdVinculo = med.IdVinculo;
                        oldMed.TipoVinculo = med.TipoVinculo;
                        oldMed.IdFornecedorCliente = med.IdFornecedorCliente;
                        oldMed.RazaoSocial = med.RazaoSocial;
                        oldMed.IdFuncionario = med.IdFuncionario;
                        oldMed.NomeFuncionario = med.NomeFuncionario;
                        oldMed.Hora = med.Hora;
                        oldMed.Avaliacao = med.Avaliacao;
                    }
                    else {
                        med.Data = new Date(med.Data);
                        med.OldCount = med.Quantidade;
                        med.ValorMedido = med.ValorItem;
                        med.IdCount = $scope.listaAvanco.length+1;
                        $scope.listaAvanco.push(med);
                    }
                });
            }

            $scope.getEtapasConstrucao();
            
        });
    }

    $scope.getMedicao = (etapa) => {
        var etapaMed = {
            Medido: 0.00,
            Medicoes: []
        };
        $scope.listaAvanco.forEach(l => {
            if (l.IdEtapa == etapa.Id) {
                etapaMed.Medido += l.PercentualEtapa;
                etapaMed.Medicoes.push(l);
            }
        });

        etapaMed.Faltam = 100 - etapaMed.Medido;
        return etapaMed;
    }

    $scope.getMedicaoItem = (etapa, item) => {
        var itemMed = {
            IdMaterial: item.IdMaterial,
            Medido: 0.00,
            Quantidade: 0.00,
            Medicoes: []
        };
        $scope.listaAvanco.forEach(l => {
            if (l.IdEtapa == etapa.Id && l.IdMaterial == item.IdMaterial) {
                itemMed.Medido += l.PercentualItem;
                itemMed.Quantidade += l.Quantidade;
                itemMed.Medicoes.push(l);
            }
        });

        itemMed.AMedir = (item.Planejado ? item.Planejado.Quantidade : item.Quantidade) - itemMed.Quantidade;
        itemMed.QtdMed = itemMed.Quantidade;
        itemMed.QtdOrca = (item.Planejado ? item.Planejado.Quantidade : item.Quantidade);
        
        itemMed.MedidoSalvo = itemMed.Medido;
        itemMed.Percento = itemMed.Medido;
        itemMed.Faltam = 100 - itemMed.Medido;

        return itemMed;
    }

    $scope.atualiza = (tipo, item, avanco) => {
        var valor = 0;
        if ($scope.comEncargos && $scope.comBDI)
            valor = item.ValorBDIEncargos;
        if (!$scope.comEncargos && $scope.comBDI)
            valor = item.ValorBDI;
        if ($scope.comEncargos && !$scope.comBDI)
            valor = item.ValorEncargos;
        if (!$scope.comEncargos && !$scope.comBDI)
            valor = item.Valor;

        valor = valor*item.Quantidade;

        switch (tipo) {
            case 0:
                avanco.Percento = (avanco.Quantidade/item.Medicao.QtdOrca)*100;
                avanco.ValorMedido = (avanco.Percento/100)*valor;
                break;
            case 1:
                avanco.Quantidade = (avanco.Percento/100)*item.Medicao.QtdOrca;
                avanco.ValorMedido = (avanco.Percento/100)*valor;
                break;
            case 2:
                avanco.Percento = (avanco.ValorMedido/valor)*100;
                avanco.Quantidade = (avanco.Percento/100)*item.Medicao.QtdOrca;
                break;
        }
        
        if (avanco.IdCompra == 0)
            item.Medicao.Medido = item.Medicao.MedidoSalvo + avanco.Percento;
        else
            item.Medicao.Medido = item.Medicao.MedidoSalvo + (avanco.Percento-avanco.OldPercento);
    }

    $scope.excluiAvanco = (etapa, item, avanco) => {
        $scope.msgBoxPergunta(item.Descricao, 'Confirma exclusão da medição?'
            , () => {
                Material.delMaterialOrcamento(avanco.IdCompra,
                    (data) => {
                        var idx = item.Medicao.Medicoes.indexOf(avanco)
                        item.Medicao.Medicoes.splice(idx, 1);
                        
                        idx = $scope.listaAvanco.indexOf(avanco);
                        $scope.listaAvanco.splice(idx,1);

                        $scope.getMedicoesFisicas();
                    });
            }
            , () => {
            });
    }

    $scope.adicionarAvanco = (etapa, item) => {
        if (!item.Medicao)
            item.Medicao = {
                IdEtapa: etapa.Id,
                IdMaterial: item.IdMaterial,
                Medido: 0.00,
                MedidoSalvo: 0.00,
                Quantidade: 0.00,
                PercentualItem: 0,
                QtdOrca: item.Quantidade,
                TipoVinculo: 0,
                Hora: 1,
                AvaliacaoSelecionado: {Id:3},
                Medicoes: []
            };

        if (item.Medicao.Medido.toFixed(2) == 100) {
            $scope.msgBoxAtencao('Medição Física', 'Item já possui 100% medido.', ()=>{});
            return;
        }
    
        var idCount = item.Medicao.Medicoes.length;
        item.Medicao.Medicoes.unshift({
            Novo: true,
            IdCompra: 0,
            IdConstrucao: $scope.construcao.Id,
            IdEtapa: etapa.Id,
            IdMaterial: item.IdMaterial,
            Quantidade: 0,
            PercentualItem: 0,
            ValorMedido: 0,
            Data: CacheApp.getData($filter("date")(Date.now(), 'yyyy-MM-ddT00:00:00Z')),
            IdCount: idCount,
            TipoVinculo: 0,
            Hora: 1,
            AvaliacaoSelecionado: {Id:3},
            Editar: $scope.getHtmlEditarMedicao()
        });
    }

    $scope.cancelaAvanco = (item, avanco) => {
        if (avanco.IdCompra == 0) {
            var idx = item.Medicao.Medicoes.indexOf(avanco)
            item.Medicao.Medicoes.splice(idx, 1);
        }
        else {
            avanco.Novo = false;
            avanco.Quantidade = avanco.OldCount;
        }
    }

    $scope.alteraAvanco = (avanco) => {
        avanco.OldCount = avanco.Quantidade;
        avanco.Editar = $scope.getHtmlEditarMedicao();
        avanco.OldPercento = avanco.PercentualItem;

        $scope.setCheckVincular(avanco, avanco.TipoVinculo)
        avanco.AvaliacaoSelecionado = {Id: avanco.Avaliacao};
        if (avanco.TipoVinculo == 2)
            avanco.FuncionarioSelecionado = {Id: avanco.IdFuncionario};
        
        avanco.Novo = true;
    }

    $scope.registraAvanco = (etapa, item, avanco) => {

        // if (item.Medicao.Medido.toFixed(2) > 100) {
        //     $scope.msgBoxErro('Medição Física', 'Medição registrada acima de 100%', function(){});
        //     return;
        // }

        avanco.objMaterial = {
            Id: avanco.IdMaterial,
            Nome: item.Descricao,
            UnidadeSigla: item.UnidadeSigla
        };

        avanco.OldCount = avanco.OldCount ? avanco.OldCount : 0;
        avanco.Etapa = etapa.Descricao;

        var paramsAvanco = {
            IdCompra: avanco.IdCompra,
            Data: avanco.Data,
            IdConstrucao: avanco.IdConstrucao,
            IdEtapa: avanco.IdEtapa,
            IdMaterial: avanco.IdMaterial,
            Quantidade: avanco.Quantidade
        }

        Compra.setMaterialAvancoFisico(paramsAvanco,
            (data) => {
                var params = {
                    IdVinculo: avanco.IdVinculo ? avanco.IdVinculo : undefined,
                    IdConstrucao: avanco.IdConstrucao,
                    IdCompra: data.Instance.IdCompra,
                    IdFornecedorCliente: avanco.TipoVinculo == 1 ? avanco.IdFornecedorCliente : (avanco.IdFornecedorCliente ? avanco.IdFornecedorCliente : undefined ),
                    IdFuncionario: avanco.TipoVinculo == 2 ? avanco.FuncionarioSelecionado.Id : (avanco.IdFuncionario ? avanco.IdFuncionario : undefined ),
                    Hora: 1,//avanco.Hora,
                    Avaliacao: 1,//avanco.AvaliacaoSelecionado.Id,
                    Vincula: avanco.TipoVinculo != 0
                };

                var vinculo = params.Vincula ? avanco.TipoVinculo : (params.IdFornecedorCliente ? 1 : (params.IdFuncionario ? 2 : 0))
                if (vinculo == 0 && avanco.Novo)
                    $scope.getMedicoesFisicas();
                else
                    switch (vinculo) {
                        case 1:
                            if (avanco.IdFuncionario) {
                                var paramsOld = {
                                    IdVinculo: avanco.IdVinculo,
                                    IdConstrucao: avanco.IdConstrucao,
                                    IdCompra: data.Instance.IdCompra,
                                    IdFuncionario: avanco.IdFuncionario,
                                    Vincula: false
                                };
                                Compra.vinculaMedicaoFuncionario(paramsOld, (dataVinculo) => {
                                    params.IdVinculo = undefined;
                                    Compra.vinculaMedicaoFornecedor(params, (dataVinculo) => {
                                        $scope.getMedicoesFisicas();
                                    })
                                })
                            }
                            else
                                Compra.vinculaMedicaoFornecedor(params, (dataVinculo) => {
                                    $scope.getMedicoesFisicas();
                                })
                            break;
                        case 2:
                            if (avanco.IdFornecedorCliente) {
                                var paramsOld = {
                                    IdVinculo: avanco.IdVinculo,
                                    IdConstrucao: avanco.IdConstrucao,
                                    IdCompra: data.Instance.IdCompra,
                                    IdFornecedorCliente: avanco.IdFornecedorCliente,
                                    Vincula: false
                                };
                                Compra.vinculaMedicaoFornecedor(paramsOld, (dataVinculo) => {
                                    params.IdVinculo = undefined;
                                    Compra.vinculaMedicaoFuncionario(params, (dataVinculo) => {
                                        $scope.getMedicoesFisicas();
                                    })
                                })
                            }
                            else
                                Compra.vinculaMedicaoFuncionario(params, (dataVinculo) => {
                                    $scope.getMedicoesFisicas();
                                })
                            break;
                    }

                avanco.Novo = false;
                avanco.IdCompra = data.Instance.IdCompra;
            });
    }

    /* FIM EDITAR COMPOSIÇÃO */

    $scope.acessarColaborador = () => {
        CacheApp.setDiarioObra({Redirecionado: true});
        $location.path('/listacolaborador');
    }

    $scope.getListaConstrucao = (callBack) => {
        $scope.sessao = CacheApp.getSessao()
        var params = {
            permissao: 'GET_AVANCO',
            refresh: $scope.refreshObra ? true: false
        }
        $scope.getListaObraCache(params, 
            (obra)=> {
                $scope.construcoes = obra
                callBack()
            }
        )
    }

    $scope.filtraObra = (obra) => {
        if (obra && obra.id) {
            $scope.setObraSelecionada($scope.construcoes.filter(c => c.Id == obra.id)[0])
        }
        else {
            $scope.orcamento = undefined;
            $scope.construcao = undefined;
            CacheApp.delConstrucao();
            $scope.listaRelatorio = [];
        }
    }

    $scope.setObraSelecionada = (obra) => {
        $scope.orcamento = undefined
        $scope.construcao = obra
        CacheApp.setConstrucao($scope.construcao)

        $scope.comEncargos = ($scope.construcao.EncargoSocial > 0)
        $scope.comBDI = $scope.construcao.BDI > 0 || $scope.construcao.BDIMaoObra > 0 || $scope.construcao.BDIMaterial > 0 || $scope.construcao.BDIEquipamento > 0 || $scope.construcao.BDIServico > 0 || $scope.construcao.BDITaxa > 0
        $scope.HtmlManterObra = undefined

        $scope.listaRelatorio = []
        $scope.listaRelatorio = $scope.reportList.filter(r => obra.Acessos.indexOf(r.Permissao) >= 0)

        $scope.loadMain()
    }

    $scope.editarObra = () => {
        if (!$scope.HtmlManterObra)
            $scope.HtmlManterObra = `
                <manterobra mo-obra="construcao">
                </manterobra>
            `;
        $scope.openObra = !$scope.openObra;
    }

    $scope.salvarObra = () => {
        $rootScope.$broadcast('salvarObra', {});
    }

    $scope.$on('refreshComboObra', (events,args) => {
        $scope.refreshObra = true
        $scope.loadObra()
    })

    $scope.loadMain = () => {
        $scope.dataInicio = new Date($scope.construcao.DataInicio);
        $scope.dataFim = new Date($scope.construcao.DataFim);
        var tempoRestante = Math.abs($scope.dataFim - $scope.dataInicio);
        $scope.dias = Math.ceil(tempoRestante / (1000 * 3600 * 24))+1;

        $scope.paginacao = { Index: 0, Pages: 999999 };
        $scope.totalAvanco = 0;
    
        $scope.getMedicoesFisicas();
        $scope.getListaFuncionario();
        $scope.getFornecedores();
    }

    $scope.loadObra = () => {
        $scope.ObraSelecionada = CacheApp.getConstrucao()
        CacheApp.delConstrucao()
        $scope.AtualizaConstrucao()
        $scope.getListaConstrucao(()=>{
            if ($scope.ObraSelecionada && $scope.construcoes.some(c => c.Id == $scope.ObraSelecionada.Id)) {
                $scope.listaSelecao = {
                    id: $scope.ObraSelecionada.Id, 
                    model: $scope.ObraSelecionada.Titulo, 
                    label: $scope.ObraSelecionada.Titulo,
                    checked: true
                }
                $scope.setObraSelecionada($scope.ObraSelecionada)
            }
            else
                $scope.orcamento = []
        })
    }

    $scope.AcessoAndroid($routeParams, (sim) => {
        $scope.AcessoMobile = sim;

        $scope.reportList = [
            { Id: 0, Descricao: 'Acompanhamento do Cronograma', Permissao: 'GET_RELATCRONFISICOFINANCEIRO', Url: 'ganttchartmeasure' },
            { Id: 1, Descricao: 'Boletim de Medição', Permissao: 'GET_BOLETIMMEDICAOI', Url: 'boletimmedicao' },
            { Id: 2, Descricao: 'Medição por Período', Permissao: 'GET_BOLETIMMEDICAOI', Url: 'medicaoperiodo' },
            { Id: 3, Descricao: 'Boletim de Medição Cliente', Permissao: 'GET_BOLETIMMEDICAOCLIENTE', Url: 'boletimmedicaocliente' },
            { Id: 4, Descricao: 'Boletim de Medição Por Fornecedor/Colaborador', Permissao: 'GET_BOLETIMMEDICAOI', Url: 'boletimmedicaofornecedor' },
            { Id: 5, Descricao: 'Boletim de Medição Lista Fornecedor/Colaborador', Permissao: 'GET_BOLETIMMEDICAOI', Url: 'boletimmedicaofornecedorall' },
            ];

        $scope.listaAvaliacao = [
            {Id: 1, Descricao: 1},
            {Id: 2, Descricao: 2},
            {Id: 3, Descricao: 3},
            {Id: 4, Descricao: 4},
            {Id: 5, Descricao: 5}
        ];

        if ($routeParams.from == 'geral') {
            $scope.loadObra()
        } else {
            $scope.construcao = CacheApp.getConstrucao()
            $scope.listaRelatorio = $scope.reportList
            $scope.loadMain()
        }


    });


  }]);
